package no.integration.svv.properties;


import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import javax.validation.constraints.NotBlank;

/**
 @author vijayjadhav
 **/

/**
 * Parameters to handle Authentication in the Atlas console
* */
@Data
@Component
@ConfigurationProperties(prefix = "authentication")
public class AuthConfigProperties {

    @NotBlank
    private String headerKey;
    @NotBlank
    private String jwks;
    @NotBlank
    private String oidc_issuer;
    @NotBlank
    private String roles;
}
