package no.integration.svv.properties;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;

/**
 @author vijayjadhav
 **/

/**
 * WS client parameters with general properties to access server
 * */
@Data
@Component
@ConfigurationProperties(prefix = "ws-client")
public class WSClientConfigProperties {

    @NotBlank
    private String locationURI;
    @NotBlank
    private String scanPackages;
    @NotEmpty
    private int connectionTimeout;
    @NotEmpty
    private int readTimeout;
    @NotEmpty
    private String securityKey;
}
