package no.integration.svv.properties;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import javax.validation.constraints.NotBlank;

/**
 @author vijayjadhav
 **/

/**
 * Properties to get parameters from the WSDL contract to create endpoint
 * */
@Data
@Component
@ConfigurationProperties(prefix = "webservice")
public class WebServiceConfigProperties {

    @NotBlank
    private String wsdlLocation;
    @NotBlank
    private String servlet;
    @NotBlank
    private String wsdlFile;
    @NotBlank
    private String portTypeName;
    @NotBlank
    private String locationUri;
    @NotBlank
    private String targetNamespace;
}
