package no.integration.svv.utils.authentication;

import com.fasterxml.jackson.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
        "kty",
        "kid",
        "use",
        "alg",
        "n",
        "e",
        "factors"
})
public class Key {

    @JsonProperty("kty")
    private String kty;
    @JsonProperty("kid")
    private String kid;
    @JsonProperty("use")
    private String use;
    @JsonProperty("alg")
    private String alg;
    @JsonProperty("n")
    private String n;
    @JsonProperty("e")
    private String e;
    @JsonProperty("factors")
    private List<Object> factors = null;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<>();

    @JsonProperty("kty")
    public String getKty() {
        return kty;
    }

    @JsonProperty("kty")
    public void setKty(String kty) {
        this.kty = kty;
    }

    @JsonProperty("kid")
    public String getKid() {
        return kid;
    }

    @JsonProperty("kid")
    public void setKid(String kid) {
        this.kid = kid;
    }

    @JsonProperty("use")
    public String getUse() {
        return use;
    }

    @JsonProperty("use")
    public void setUse(String use) {
        this.use = use;
    }

    @JsonProperty("alg")
    public String getAlg() {
        return alg;
    }

    @JsonProperty("alg")
    public void setAlg(String alg) {
        this.alg = alg;
    }

    @JsonProperty("n")
    public String getN() {
        return n;
    }

    @JsonProperty("n")
    public void setN(String n) {
        this.n = n;
    }

    @JsonProperty("e")
    public String getE() {
        return e;
    }

    @JsonProperty("e")
    public void setE(String e) {
        this.e = e;
    }

    @JsonProperty("factors")
    public List<Object> getFactors() {
        return factors;
    }

    @JsonProperty("factors")
    public void setFactors(List<Object> factors) {
        this.factors = factors;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

}