package no.integration.svv.utils.mapper;

import no.geointegrasjon.rep.arkiv.dokument.xml_schema._2012_01.*;
import no.geointegrasjon.rep.arkiv.oppdatering.xml_wsdl._2012_01.NyDokument;
import no.vegvesen.saksarkiv.felles.typer._1.NyttVedleggKvitteringType;
import no.vegvesen.saksarkiv.felles.typer._1.VedleggIdentifikatorType;
import org.springframework.http.MediaType;

import javax.activation.DataHandler;
import javax.mail.util.ByteArrayDataSource;
import java.nio.charset.StandardCharsets;

public class DokumentMapTestFixture {

    public static NyDokument ndRequest() {
        NyDokument geoInput = new NyDokument();

        Dokument dokument = new Dokument();

        dokument.setDokumentnummer("s1266017");
        Dokumenttype dokumenttype = new Dokumenttype();
        dokumenttype.setKodeverdi("Saksdokument1");
        dokument.setDokumenttype(dokumenttype);
        dokument.setTittel("DokTittle");
        dokument.setSystemID("s1266017");
        TilknyttetRegistreringSom tilknyttetRegistreringSom = new TilknyttetRegistreringSom();
        tilknyttetRegistreringSom.setKodeverdi("H");
        Filinnhold fil = new Filinnhold();

        Format format = new Format();
        format.setKodeverdi("pdf");
        fil.setFilnavn("Julaften3");
        fil.setMimeType("application/pdf");

        String baseVal = "TGVnZ1RpbE55dHREb2t1bWVudEpvdXJuYWxwb3N0UmVxdWVzdFR5cGUNCnh4eA0KYWFh";
        ByteArrayDataSource byteArrayDataSource = new ByteArrayDataSource(new byte[0], MediaType.APPLICATION_OCTET_STREAM_VALUE);
        byte[] bytes = baseVal.getBytes(StandardCharsets.UTF_8);
//        byte[] bytes = geoInput.getDokument().getFil().getBase64();
        byteArrayDataSource = new ByteArrayDataSource(bytes, MediaType.APPLICATION_OCTET_STREAM_VALUE);
        DataHandler dataHandler = new DataHandler(byteArrayDataSource);
        fil.setBase64(bytes);

        dokument.setFil(fil);
        dokument.setFormat(format);
        geoInput.setDokument(dokument);
        return geoInput;
    }


    public static NyttVedleggKvitteringType ndResponse() {
        NyttVedleggKvitteringType nyttVedleggKvitteringType = new NyttVedleggKvitteringType();

        VedleggIdentifikatorType vedleggIdentifikatorType = new VedleggIdentifikatorType();

        vedleggIdentifikatorType.setDokumentId("12321232");

        nyttVedleggKvitteringType.getDokument().add(vedleggIdentifikatorType);

        return nyttVedleggKvitteringType;
    }

}
