package no.integration.svv.utils.mapper;

import no.geointegrasjon.rep.arkiv.felles.xml_schema._2012_01.Saksnummer;
import no.geointegrasjon.rep.arkiv.kjerne.xml_schema._2012_01.*;
import no.geointegrasjon.rep.arkiv.oppdatering.xml_wsdl._2012_01.NyJournalpost;
import no.geointegrasjon.rep.felles.adresse.xml_schema._2012_01.ElektroniskAdresseListe;
import no.geointegrasjon.rep.felles.adresse.xml_schema._2012_01.Epost;
import no.geointegrasjon.rep.felles.adresse.xml_schema._2012_01.Faks;
import no.geointegrasjon.rep.felles.adresse.xml_schema._2012_01.Telefon;
import no.geointegrasjon.rep.felles.kontakt.xml_schema._2012_01.Kontakt;
import no.geointegrasjon.rep.felles.teknisk.xml_schema._2012_01.ArkivKontekst;
import no.vegvesen.saksarkiv.felles.typer._1.JournalpostIdType;
import no.vegvesen.saksarkiv.felles.typer._1.JournalpostIdentifikatorType;
import no.vegvesen.saksarkiv.felles.typer._1.JournalpostKvitteringType;
import no.vegvesen.saksarkiv.felles.typer._1.MappeIdType;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.math.BigInteger;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;

class JournalPostTestFixture {



    public static NyJournalpost jpRequest() throws DatatypeConfigurationException, ParseException {
        NyJournalpost geoInput = new NyJournalpost();
        Journalpost journalpost = new Journalpost();


        ArkivKontekst arkivKontekst = new ArkivKontekst();
        arkivKontekst.setKlientnavn("klientName");
        arkivKontekst.setSluttbruker("sluttBruker");
        Date date = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss").parse("2022-01-14 11:15:00");

        journalpost.setSkjermetTittel(Boolean.TRUE);
        journalpost.setJournalpostnummer("24323");
        journalpost.setSystemID("444");
        journalpost.setOffentligTittel("OffentligTittel");
        journalpost.setAntallVedlegg("AntallVedlegg");
        journalpost.setDokumentetsDato(dateConv(date));
//        System.out.println(dateConv(date));
        journalpost.setForfallsdato(dateConv(date));
        journalpost.setJournaldato(dateConv(date));
        journalpost.setTilgangsgruppeNavn("Alle");
        journalpost.setTittel("Jobbanalyse");
        journalpost.setTilleggskode("Tilleggskode");

        Journalnummer journalnummer = new Journalnummer();
        journalnummer.setJournalsekvensnummer(new BigInteger(String.valueOf(54345)));
        journalnummer.setJournalaar(new BigInteger( String.valueOf(22)));
        journalpost.setJournalnummer(journalnummer);

        Journalposttype journalposttype = new Journalposttype();
        journalposttype.setKodeverdi("alle");
        journalposttype.setKodebeskrivelse("Kodebeskrivelse");
        journalposttype.setErGyldig(Boolean.FALSE);
        journalpost.setJournalposttype(journalposttype);


        Journalstatus journalstatus = new Journalstatus();
        journalstatus.setKodeverdi("R");
        journalstatus.setKodebeskrivelse("Kodebeskrivelse");
        journalstatus.setErGyldig(Boolean.FALSE);
        journalpost.setJournalstatus(journalstatus);




        KorrespondansepartListe korrespondansepartListe = new KorrespondansepartListe();
        Korrespondansepart korrespondansepart = new Korrespondansepart();

        Kontakt kontakt = new Kontakt();
        kontakt.setNavn("KontNavn");
        ElektroniskAdresseListe elektroniskAdresseListe = new ElektroniskAdresseListe();

        Epost epost = new Epost();
        Faks faks = new Faks();
        Telefon telefon = new Telefon();
        epost.setEpostadresse("Epostadresse");
        faks.setFaksnummer("FaksNum");
        telefon.setTelefonnummer("43234323");
        elektroniskAdresseListe.getListe().add(epost);
        elektroniskAdresseListe.getListe().add(faks);
        elektroniskAdresseListe.getListe().add(telefon);

        kontakt.setElektroniskeAdresser(elektroniskAdresseListe);
        korrespondansepart.setKontakt(kontakt);
        Journalenhet journalenhet = new Journalenhet();
        journalenhet.setKodeverdi("R");
        journalenhet.setKodebeskrivelse("Kodebeskrivelse");
        journalenhet.setErGyldig(Boolean.FALSE);
        korrespondansepart.setJournalenhet(journalenhet);
        Forsendelsesmaate forsendelsesmaate = new Forsendelsesmaate();
        forsendelsesmaate.setKodeverdi("R");
        forsendelsesmaate.setKodebeskrivelse("Kodebeskrivelse");
        forsendelsesmaate.setErGyldig(Boolean.FALSE);
        korrespondansepart.setForsendelsesmaate(forsendelsesmaate);
        Korrespondanseparttype korrespondanseparttype = new Korrespondanseparttype();

        korrespondanseparttype.setKodeverdi("R");
        korrespondanseparttype.setKodebeskrivelse("Kodebeskrivelse");
        korrespondanseparttype.setErGyldig(Boolean.FALSE);
        korrespondansepart.setBehandlingsansvarlig("Behandlingsansvarlig");
        korrespondansepart.setSkjermetKorrespondansepart(Boolean.FALSE);
        korrespondansepart.setFristBesvarelse(dateConv(date));
        korrespondansepart.setAdministrativEnhetInit("FGA40");
        korrespondansepart.setSaksbehandlerInit("tytors");
        korrespondansepart.setKorrespondanseparttype(korrespondanseparttype);
        korrespondansepartListe.getListe().add(korrespondansepart);

        journalpost.setKorrespondansepart(korrespondansepartListe);

        MerknadListe merknadListe = new MerknadListe();
        Merknad merknad = new Merknad();
        merknad.setMerknadsdato(dateConv(date));
        merknad.setMerknadRegistrertAv("MerknadRegist");
        merknad.setMerknadstekst("Merknadstekst");
        merknad.setSystemID("MerSysID");
        merknad.setMerknadstype("merknadst");
        merknad.setMerknadRegistrertAvInit("MerknadRegistrertAvInit");
        merknadListe.getListe().add(merknad);
        journalpost.setMerknader(merknadListe);

        Arkivdel arkivdel = new Arkivdel();
        arkivdel.setKodeverdi("R");
        arkivdel.setKodebeskrivelse("Kodebeskrivelse");
        arkivdel.setErGyldig(Boolean.FALSE);
        journalpost.setReferanseArkivdel(arkivdel);


        AvskrivningListe avskrivningListe = new AvskrivningListe();

        Avskrivning avskrivning = new Avskrivning();
        avskrivning.setAvskrevetAv("AvskrevetAv");
        avskrivningListe.getListe().add(avskrivning);
        journalpost.setReferanseAvskrivninger(avskrivningListe);

        EksternNoekkel eksternNoekkel = new EksternNoekkel();
        eksternNoekkel.setNoekkel("tytors");
        eksternNoekkel.setFagsystem("Grunnerverv");
        journalpost.setReferanseEksternNoekkel(eksternNoekkel);
        journalpost.setReferanseMappeEksternNoekkel(eksternNoekkel);


        SakSystemId sakSystemId = new SakSystemId();

        SystemID systemID = new SystemID();
        systemID.setId("SysId");
        sakSystemId.setSystemID(systemID);
        journalpost.setReferanseSakSystemID(sakSystemId);

        Saksnummer saksnummer = new Saksnummer();
        saksnummer.setSaksaar(new BigInteger(String.valueOf(21)));
        saksnummer.setSakssekvensnummer(new BigInteger(String.valueOf(43234)));
        journalpost.setSaksnr(saksnummer);

        Skjerming skjerming = new Skjerming();
        skjerming.setSkjermingshjemmel("Skjermjemmel");
        skjerming.setSkjermingOpphoererDato(dateConv(date));
        SkjermingOpphorerAksjon skjermingOpphorerAksjon = new SkjermingOpphorerAksjon();
        skjermingOpphorerAksjon.setKodeverdi("R");
        skjermingOpphorerAksjon.setKodebeskrivelse("Kodebeskrivelse");
        skjermingOpphorerAksjon.setErGyldig(Boolean.FALSE);
        skjerming.setSkjermingOpphoererAksjon(skjermingOpphorerAksjon);
        journalpost.setSkjerming(skjerming);


        TilleggsinformasjonListe tilleggsinformasjonListe = new TilleggsinformasjonListe();
        Tilleggsinformasjon tilleggsinformasjon = new Tilleggsinformasjon();

        Informasjonstype informasjonstype = new Informasjonstype();
        informasjonstype.setKodeverdi("R");
        informasjonstype.setKodebeskrivelse("Kodebeskrivelse");
        informasjonstype.setErGyldig(Boolean.FALSE);
        tilleggsinformasjon.setInformasjonstype(informasjonstype);

        Tilgangsrestriksjon tilgangsrestriksjon = new Tilgangsrestriksjon();
        tilgangsrestriksjon.setKodeverdi("R");
        tilgangsrestriksjon.setKodebeskrivelse("Kodebeskrivelse");
        tilgangsrestriksjon.setErGyldig(Boolean.FALSE);
        tilleggsinformasjon.setTilgangsrestriksjon(tilgangsrestriksjon);
        tilleggsinformasjon.setSystemID("sysId44");
        tilleggsinformasjon.setTilgangsgruppeNavn("Alle");
        tilleggsinformasjon.setRekkefoelge("RekkFolge");
        tilleggsinformasjon.setRegistrertDato(dateConv(date));
        tilleggsinformasjon.setRegistrertAvInit("ReiAvInit");
        tilleggsinformasjon.setOppbevaresTilDato(dateConv(date));
        tilleggsinformasjon.setInformasjon("Inform");

        tilleggsinformasjonListe.getListe().add(tilleggsinformasjon);
        journalpost.setTilleggsinformasjon(tilleggsinformasjonListe);
        geoInput.setKontekst(arkivKontekst);


        geoInput.setJournalpost(journalpost);

        return geoInput;

    }

    public static JournalpostKvitteringType jpResponse() throws DatatypeConfigurationException, ParseException{

        JournalpostKvitteringType mimeInput = new JournalpostKvitteringType();

        JournalpostIdentifikatorType journalpostIdentifikatorType = new JournalpostIdentifikatorType();
        JournalpostIdType journalpostIdType = new JournalpostIdType();
        MappeIdType mappeIdType = new MappeIdType();

        mappeIdType.setSaksnummer("22/323234");
        journalpostIdType.setMappeId(mappeIdType);
        journalpostIdType.setLopenummer("3333333");
        journalpostIdentifikatorType.setDokumentId("5555555");

        journalpostIdentifikatorType.setJournalpostId(journalpostIdType);

        mimeInput.setRegistrering(journalpostIdentifikatorType);
        return mimeInput;
    }


    public static XMLGregorianCalendar dateConv(Date dt) throws DatatypeConfigurationException, ParseException {
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        Date date = format.parse("2022-01-14 11:15:00");
        GregorianCalendar cal = new GregorianCalendar();
        cal.setTime(date);
        XMLGregorianCalendar xmlGregCal = DatatypeFactory.newInstance().newXMLGregorianCalendar(cal);
//        System.out.println(xmlGregCal);
        return xmlGregCal;

    }
}